
    <hr>
    <div id="file" type="file"></div>
    <span style="display:none" class="info" id="font-name"></span>
    <canvas id="preview" width="1000" height="400" class="text"></canvas>
    <div id="message"></div>
    <input type="text" class="text-input" onkeyup="renderText()" value="Points"  id="textField">
    <label>Font Size<input type="range" min="6" max="500" step="2" value="338" id="font-size-range" autocomplete="on"><span id="fontSize">338</span></label>
    <label><input type="checkbox" onchange="drawPointsChanged(this)" checked="checked" >Points</label>
    <label><input type="checkbox" onchange="drawMetricsChanged(this)">Metrics</label>
    <label><input type="checkbox" onchange="kerningChanged(this)" checked="checked">Kerning</label>

    <hr>


<script type="text/javascript">
var font = null;
var fontSize = 338;
var textToRender = "Points";
var drawPoints = false;
var drawMetrics = false;
var kerning = true;
var previewPath = null;
var snapPath = null;
var snapStrength = 80;
var snapDistance = 53;
var snapX = 0;
var snapY = 0;
var fontSizeSlider = document.getElementById("font-size-range");


function drawPointsChanged(e) {
    drawPoints = e.checked;
    renderText();
}

function drawMetricsChanged(e) {
    drawMetrics = e.checked;
    renderText();
}

function kerningChanged(e) {
    kerning = e.checked;
    renderText();
}

function fontSizeChanged() {
    fontSize = fontSizeSlider.value;
    document.getElementById('fontSize').innerHTML = '' + fontSize;
    renderText();
}

function snapStrengthChanged(e) {
    snapStrength = e.value;
    document.getElementById('snapStrength').innerHTML = '' + snapStrength;
    renderText();
}

function snapDistanceChanged(e) {
    snapDistance = e.value;
    document.getElementById('snapDistance').innerHTML = '' + snapDistance;
    renderText();
}

function snapXChanged(e) {
    snapX = e.value * 1.0;
    document.getElementById('snapX').innerHTML = '' + snapX;
    renderText();
}

function snapYChanged(e) {
    snapY = e.value * 1.0;
    document.getElementById('snapY').innerHTML = '' + snapY;
    renderText();
}

// Round a value to the nearest "step".
function snap(v, distance, strength) {
    return (v * (1.0 - strength)) + (strength * Math.round(v / distance) * distance);
}

function doSnap(path) {
    var i;
    var strength = snapStrength / 100.0;
    for (i = 0; i < path.commands.length; i++) {
        var cmd = path.commands[i];
        if (cmd.type !== 'Z') {
            cmd.x = snap(cmd.x + snapX, snapDistance, strength) - snapX;
            cmd.y = snap(cmd.y + snapY, snapDistance, strength) - snapY;
        }
        if (cmd.type === 'Q' || cmd.type === 'C') {
            cmd.x1 = snap(cmd.x1 + snapX, snapDistance, strength) - snapX;
            cmd.y1 = snap(cmd.y1 + snapY, snapDistance, strength) - snapY;
        }
        if (cmd.type === 'C') {
            cmd.x2 = snap(cmd.x2 + snapX, snapDistance, strength) - snapX;
            cmd.y2 = snap(cmd.y2 + snapY, snapDistance, strength) - snapY;
        }
    }
}

function renderText() {
    if (!font) return;
    textToRender = document.getElementById('textField').value;

    var previewCtx = document.getElementById('preview').getContext("2d");
    previewCtx.clearRect(0, 0, 1000, 400);

    font.draw (previewCtx, textToRender, 0, 310, fontSize, {kerning: kerning});

    if (drawPoints) {
        font.drawPoints(previewCtx, textToRender, 0, 310, fontSize, {kerning: kerning});
    }
    if (drawMetrics) {
        font.drawMetrics(previewCtx, textToRender, 0, 310, fontSize, {kerning: kerning});
    }

    snapPath = font.getPath(textToRender, 0, 310, fontSize, {kerning: kerning});
    doSnap(snapPath);
    var snapCtx = document.getElementById('snap').getContext("2d");
    snapCtx.clearRect(0, 0, 1000, 400);
    snapPath.draw(snapCtx);
}

// Create a canvas and adds it to the document.
// Returns the 2d drawing context.
function createGlyphCanvas(glyph, size) {
    var canvasId, html, glyphsDiv, wrap, canvas, ctx;
    canvasId = 'c' + glyph.index;
    html = '<div class="wrapper" style="width:' + size + 'px"><canvas id="' + canvasId + '" width="' + size + '" height="' + size + '"></canvas><span>' + glyph.index + '</span></div>';
    glyphsDiv = document.getElementById('glyphs');
    wrap = document.createElement('div');
    wrap.innerHTML = html;
    glyphsDiv.appendChild(wrap);
    canvas = document.getElementById(canvasId);
    ctx = canvas.getContext('2d');
    return ctx;
}

function showErrorMessage(message) {
    var el = document.getElementById('message');
    if (!message || message.trim().length === 0) {
        el.style.display = 'none';
    } else {
        el.style.display = 'block';
    }
    el.innerHTML = message;
}

function onFontLoaded(font) {
    var glyphsDiv, i, x, y, fontSize;
    window.font = font;

    // Show the first 100 glyphs.
    glyphsDiv = document.getElementById('glyphs');
    glyphsDiv.innerHTML = '';

    amount = Math.min(100, font.glyphs.length);
    x = 50;
    y = 120;
    fontSize = 72;
    for (i = 0; i < amount; i++) {
        glyph = font.glyphs[i];
        ctx = createGlyphCanvas(glyph, 150);
        glyph.draw(ctx, x, y, fontSize);
        glyph.drawPoints(ctx, x, y, fontSize);
        glyph.drawMetrics(ctx, x, y, fontSize);
    }

    renderText();
}

function onReadFile(e) {
    document.getElementById('font-name').innerHTML = '';
    var file = e.target.files[0];
    var reader = new FileReader();
    reader.onload = function (e) {
        try {
            font = opentype.parse(e.target.result);
            onFontLoaded(font);
            showErrorMessage('');
        } catch (err) {
            showErrorMessage(err.toString());
        }
    }
    reader.onerror = function (err) {
        showErrorMessage(err.toString());
    }

    reader.readAsArrayBuffer(file);
}

var fontFileName = 'fonts/Career.otf';

document.getElementById('font-name').innerHTML = fontFileName.split('/')[1];

var fileButton = document.getElementById('file');
fileButton.addEventListener('change', onReadFile, false);

// FireFox & Chrome fire the 'input' event continuously, then the 'change' event on mouse up.
// IE 11 doesn't fire the 'input' event at all, but che 'change' event continuously.
fontSizeSlider.addEventListener('input', fontSizeChanged, false);
fontSizeSlider.addEventListener('change', fontSizeChanged, false);

opentype.load(fontFileName, function (err, font) {
    var amount, glyph, ctx, x, y, fontSize;
    if (err) {
        showErrorMessage(err.toString());
        return;
    }
    onFontLoaded(font);
});
</script>
